﻿Imports System.Net
Imports System.Net.Sockets
Imports System.Threading
Imports System.Text
Imports System.IO
Imports System.ComponentModel

Public Class WebServerMain

    Dim hostName As String = Dns.GetHostName()
    Dim serverIP() As IPAddress = Dns.GetHostAddresses(Dns.GetHostName())
    Dim Port As String = "80"
    Dim tcpListener As New TcpListener(serverIP(2), Int32.Parse(Port))

    Dim httpSession As New HTTPSessione(tcpListener)
    Dim ServerThread As Thread

    Private Sub WebServerMain_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        Try

            'For Each address As IPAddress In serverIP
            '    If address.AddressFamily = AddressFamily.InterNetwork Then
            '        Console.WriteLine($"{address} is IPv4")
            '    End If
            'Next

            tcpListener.Start()
            httpSession = New HTTPSessione(tcpListener)

            ServerThread = New Thread(AddressOf httpSession.ProcessThread)

            ServerThread.Start()

            AddHandler httpSession.InfoGenerali, AddressOf Me.InfoVerifico

        Catch ex As Exception
            Console.WriteLine(ex.StackTrace.ToString())
        End Try

        LblIP.Text = "IP; " & serverIP(2).ToString & "   " & hostName


    End Sub

    Delegate Sub InfoVerificoDelegate(ByVal InfoDati As String)
    Private Sub InfoVerifico(ByVal InfoDati As String)
        If Me.InvokeRequired Then
            Me.Invoke(New InfoVerificoDelegate(AddressOf InfoVerifico), New Object() {InfoDati})
            Return
        End If

        RtxRichieste.AppendText(InfoDati & Convert.ToChar(Keys.Return) & Convert.ToChar(Keys.LineFeed))

        If InfoDati.Contains("ClientThread N° ") Then

            RtxRichieste.Select(RtxRichieste.TextLength - 1 - InfoDati.Length, InfoDati.Length)
            RtxRichieste.SelectionColor = Color.Red

        ElseIf InfoDati.Contains("Client: ") Then

            RtxRichieste.Select(RtxRichieste.TextLength - 1 - InfoDati.Length, InfoDati.Length)
            RtxRichieste.SelectionColor = Color.YellowGreen

        ElseIf InfoDati.Contains("Richiesta: ") Then

            RtxRichieste.Select(RtxRichieste.TextLength - 1 - InfoDati.Length, InfoDati.Length)
            RtxRichieste.SelectionColor = Color.Green

        ElseIf InfoDati.Contains("Risposta: ") Then
            RtxRichieste.Select(RtxRichieste.TextLength - 1 - InfoDati.Length, InfoDati.Length)
            RtxRichieste.SelectionColor = Color.Blue

        End If


    End Sub


    Private Sub WebServerMain_Closed(sender As Object, e As EventArgs) Handles Me.Closed
        tcpListener.Stop()
        ServerThread.Abort()
    End Sub


End Class
